/*
    pkdump.c - Port scanning Detection version 0.96.2 
    Copyright (c) 2003  Fabio Salvucci (dsmoker@libero.it) 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <time.h>

#include <sys/socket.h>
#include <features.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <linux/if.h>

#include <pthread.h>

#include <signal.h>

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>


#define HEADER 24
#define UPCKT  131073
#define PCKT   65536 

unsigned int SrcPort = 1024 ,DstPort = 1024 ;


struct Header {  
    
        unsigned char *packet_data ;
   
        unsigned int packet_lenght;
    
        struct Header *next ;

}*header = NULL;

struct FD {
   
       int fd ;
}Fd;

struct Header *start ;

pthread_t thread1ID ,thread2ID ;   

char *Flags_name[] = {"DUMMY","NULL" ,"UDPNULL" ,"UDPPORT" ,
                      "FIN","SYN","RST","PSH","ACK","URG","XMAS" ,
                      NULL 
                     }; 


unsigned short int Flags_value[] = { 0xFF ,0x40 ,0x41 ,0x42 ,
                                     0x1 ,0x2 ,0x4 ,0x8 ,0x10 ,0x20, 0x29 ,
                                     0x0
                                   };
   
char *Options_name[] = { "DUMMY" ,"-U" ,"-T" ,NULL };
unsigned short int  Option_value[]  = { 0xFF ,0x01 ,0x02 ,0x00 };  
   

struct FLAGS {
   
       unsigned short int  flags;
       struct FLAGS       *next ;

}*Flags=NULL;

struct OPTIONS {
       
       unsigned short int   opt ; 
       unsigned short int   sport ;
       unsigned short int   eport ;
       unsigned int         saddress;
       unsigned short int   mask ;
       struct               OPTIONS *next;

}*Options=NULL ;


char *Directory = NULL ;


FILE *Out1 = NULL ;


char *stcat ( char *p ,char *q ,int slash ) {
   
     char *data ,*dummy ,*point1 = p ,*point2 = q;
   
     if ( !q || !p ) { printf ("\nERROR :No directory \n\n");exit(1);}
   
     if ((data = (char*)malloc( strlen(p) + strlen (q) + 4 )) == NULL ){
	   
	       fprintf (stdout ,"\nERROR :No memory \n\n") ;
	      
	       exit(1);
     }
   	
     dummy = data ;
	
     while ( *point1 ) { 
	
	if ( iscntrl(*point1) ) {point1++;continue ;} 
	
	*dummy = *point1 ;dummy++ ;
	
	point1++;
     }
   
     if ( slash ) *(dummy++) = '/' ;
     
     while ( *point2 ) { 
	
	if ( iscntrl (*point2) ) {point2++;continue ;}
	
	*dummy = *point2 ;dummy++ ;
	     
        point2++;
      
     }
     
     *(dummy++) = '\0' ;
   
     return (data);
   
}     
	   
   

int if_pr_set (char *if_net_name) 
{

 int fd ;
 struct ifreq ifr ;
 int s ;

 fd = socket ( PF_PACKET ,SOCK_DGRAM , htons (ETH_P_IP) );  
 if (fd < 0 ) {
     
     fprintf (stdout ,"\nERROR :Cant get PACKET SOCKET socket\n"); 
     fprintf (stdout ,"compile packet socket in your kernel or\n ");
     fprintf (stdout ,"insert it as a module ( af_packet.o ) \n\n" );
     exit(0);
 }
   
 strcpy (ifr.ifr_name ,if_net_name );
   
 s = ioctl ( fd ,SIOCGIFFLAGS ,&ifr );
   
 if ( s<0 ) { 
 
    close ( fd ); 
    fprintf (stdout ,"\nERROR :Can't find interface \n\n");
    exit (0);
 }
   
 ifr.ifr_flags |= (IFF_PROMISC|IFF_DEBUG) ;
   
 s = ioctl ( fd ,SIOCSIFFLAGS ,&ifr ) ;
   
 if ( s < 0 ) fprintf (stdout , "\nERROR :can't set promiscuos mode\n\n" );
   
 return (fd) ;  
   
}

char *reverse ( char *s ) 
{
  int c ,i ,j ;

  for ( i = 0 ,j = strlen (s) - 1 ;i<j ;i++ ,j-- ) {
      
      c = *(s+i);

      *(s+i) = *(s+j) ;

      *(s+j) = c;
  }
  return (s);
}  
 
char *citoa ( unsigned char  n ,char *s ) 
{
  unsigned char  i ,dummy ;

  i =0 ;

  do {

     dummy = n % 16 + '0' ;
     
     if ( dummy >= 0x3A ) dummy += 7 ;
     
     *(s+(i++)) = dummy ;
     
  } while ( ( n /= 16 ) > 0 );

  *(s+i) = '\0' ;

  if ( strlen (s) == 1 ) { *(s+1) = '0' ;*(s+2) = '\0' ;} 
   
  s = reverse ( s ) ;

  return ( s ) ;
}   

char *iitoa ( unsigned int n ,char *s ) 
{
  unsigned char  i ,dummy ;

  i =0 ;

  do {

     dummy = n % 16 + '0' ;
     
     if ( dummy >= 0x3A ) dummy += 7 ;
     
     *(s+(i++)) = dummy ;
     
  } while ( ( n /= 16 ) > 0 );

  *(s+i) = '\0' ;

  if ( strlen (s) == 1 ) { *(s+1) = '0' ;*(s+2) = '\0' ;} 
   
  s = reverse ( s ) ;

  return ( s ) ;
}   


char *ip_disasm ( char *frag ,char *where)
{

   unsigned char dummy ;
   char *value = where ;
     
     
   while ( *frag ) {
   
         if ( *frag >= 'A' ) dummy = *frag - 55 ;	      
         else dummy = *frag - 48 ;
	      	      
         dummy *= 16 ;
	      
	      
         if ( *(frag+1) >= 'A' ) dummy += *(frag+1) - 55 ;
         else dummy += *(frag+1) - 48 ;
	      
	 *(value++) = dummy ;     

         frag += 2;
   }

   return (where);

}

      

struct Header *ip_assembly ( unsigned char *packet_fragment )
{
   
   struct Header *head ;

   struct Ufrag {

          unsigned short int lenght ;
          unsigned short int offset ;
          unsigned char     *packet ;
          struct Ufrag      *next   ;
   };
   
   struct Mfrag {
          struct tm          *loctime ;
          unsigned short int fragment ;   
          unsigned short int identification ;
          struct Ufrag       *ufrag ;
          struct Mfrag       *next  ;
          struct Mfrag       *prev  ;
   };	
      
   static struct Mfrag *mfrag = 0 ;
   struct Mfrag *mpck = 0 ,*mummy  ,*mummy0 ;
   struct Ufrag *upck = 0 ,*uummy1 ,*uummy2;  

   char pkbuild[UPCKT] ;   
      
   unsigned short int header ,id ,lenght ,offset ,fragment;
   char   byte[3] ,*tmp;
   int    count ,mcount ,ccount ;
   
   unsigned short int ident ,tl ,fo ;

   struct tm *loctime ;
   time_t curtime ;

   curtime = time (NULL);  
    
   loctime = localtime (&curtime);    

   
   fragment = packet_fragment[6] & 0x20 ;
   
   header = ( packet_fragment[0] & 0x0F  ) * 4  ; 
   
   id   = packet_fragment[4];
   id <<=8;
   id  += packet_fragment[5];   
   
   lenght   = packet_fragment[2] ;	      
   lenght <<= 8 ;	
   lenght  += packet_fragment[3] ;
   
   offset   = packet_fragment[6] & 0x1F ;
   offset <<= 8 ;
   offset  += packet_fragment[7] ;
   
   if (!mfrag) {
      
      if ( (mpck=mfrag=(struct Mfrag*) malloc ( sizeof (struct Mfrag))) == 0){
	 
	 fprintf (stdout , "\nERROR :No space for fragment 1\n\n" );
	 
	 exit(1);
      }
      
      mpck->loctime = loctime ;
      
      if (fragment) mpck->fragment = 1;
      else mpck->fragment = 0 ;
      
      mpck->identification   = id;

      if ( (mpck->ufrag=(struct Ufrag*) malloc ( sizeof (struct Ufrag))) == 0){
	 
	 fprintf ( stdout ,"\nERROR :No space for fragment 2\n\n" );
	 
	 exit(1);
      }

      mpck->ufrag->lenght = lenght ;
      mpck->ufrag->offset = offset ;
      
      if ( (mpck->ufrag->packet=(char*)malloc (lenght)) == 0){
	 
	 fprintf ( stdout ,"\nERROR :No space for fragment 3\n\n" );
	 
	 exit(1);
      }

      memcpy ( mpck->ufrag->packet ,packet_fragment ,lenght );
      
      mpck->ufrag->next = NULL ;
      
      mpck->next = NULL ;
      mpck->prev = NULL ;
						 
   }
   
   else {

      mpck = mfrag ;
      
      while (mpck) {
	 
	    mummy = mpck ;
	 
	    if ( mpck->identification == id ) break ;
	    
	    mpck = mpck->next ;
      }

      if ( mpck ) {

       if (fragment) mpck->fragment = 1;
       else mpck->fragment = 0 ;

       upck = mpck->ufrag ;
	 
       while ( upck->next ) upck = upck->next ;
	 
       if ( (upck->next=(struct Ufrag*) malloc ( sizeof (struct Ufrag))) == 0){
	 
	 fprintf  (stdout , "\nERROR :No space for fragment 4\n\n" );
	 
	 exit(1);
       }

       upck = upck->next ;
	 
       upck->lenght = lenght - header  ;
       upck->offset = offset ;
      
       if ( (upck->packet=(char*)malloc (lenght-header)) == 0){
	 
	 fprintf (stdout ,"\nERROR :No space for fragment 5\n\n" );
	 
	 exit(1);
       }

       memcpy ( upck->packet ,&packet_fragment[header] ,lenght-header );
      
       upck->next = NULL ;
      	 
      }
      else {

       mpck = mummy;	 
	 
       if ((mpck->next=(struct Mfrag*) malloc ( sizeof (struct Mfrag))) == 0){
	 
	  fprintf (stdout , "\nERROR :No space for fragment 6\n\n" );
	 
	  exit(1);
       
       }

       mummy = mpck ;
	 
       mpck = mpck->next ;
	 
       mpck->prev = mummy ;
	 
       mpck->next = NULL ;
 
       mpck->loctime = loctime ;	 
	 
       if (fragment) mpck->fragment = 1;
       else mpck->fragment = 0 ;	 
	 
       mpck->identification   = id;	 
	 
       if ((mpck->ufrag=(struct Ufrag*) malloc ( sizeof (struct Ufrag))) == 0){
	 
	 fprintf ( stdout ,"\nERROR :No space for fragment 7\n\n" );
	 
	 exit(1);
       }

       mpck->ufrag->lenght = lenght ;
       mpck->ufrag->offset = offset ;
      
       if ( (mpck->ufrag->packet=(char*)malloc (lenght)) == 0){
	 
	 fprintf ( stdout ,"\nERROR :No space for fragment 8\n\n" );
	 
	 exit(1);
       }

       memcpy ( mpck->ufrag->packet ,packet_fragment ,lenght );
      
       mpck->ufrag->next = NULL ;
      
						 
      }
      

      
   }

   mpck = mfrag ;
   
   while (mpck) {
	 
      if ( !mpck->fragment ) {
loop:
       uummy1 = mpck->ufrag ;	 
       
       for ( count = 0 ; count < UPCKT ; count++) pkbuild[count] = '\0'; 
	 
       while (uummy1) {
	 
	if ( ( uummy1->offset + uummy1->lenght ) >= PCKT ) {  
              fprintf (stdout, "\nALERT :Fragment out of the size !!\n\n") ;
	      fprintf (stdout,"\a\a");
	      fflush  ( stdout );
	      uummy1 = uummy1->next ;
	      continue ;
	}
	
        for ( mcount = 0 ,ccount = uummy1->offset*2  ;
	      mcount < uummy1->lenght  ;
	      mcount ++ ,ccount += 2         ) {
	   
	      tmp = citoa ( uummy1->packet[mcount] ,byte );
	 
	      pkbuild[ccount]   = *tmp;
	                  
              pkbuild[ccount+1] = *(tmp+1) ;

	  
         }
	 
	 uummy1 = uummy1->next;
       }
	 
       head = (struct Header*)malloc (sizeof (struct Header)) ;  

       head->packet_lenght = strlen (pkbuild) / 2 ;
	 
       if (( head->packet_data = 
	                (char*) malloc (head->packet_lenght+1)) == NULL ) {
              fprintf (stdout, "\nERROR :No space for fragment 9\n\n") ;
              exit (1) ;
       }
	 
	 
       head->packet_data = ip_disasm ( pkbuild ,head->packet_data);
	 	 
       if ( mpck->prev) {

	 mummy = mpck->next ;
	  
	 mummy0 = mpck ;
	  
	 mpck = mpck->prev ;
	  
	 mpck->next = mummy ;
	  
	 mpck->next->prev = mpck ;
	  
	    	    
         uummy1 = mummy0->ufrag ;           
       
         while ( uummy1 ) {
	  
	       if (uummy1->next) uummy2 = uummy1->next ;
	       else uummy2 = NULL ;
	  
	       free ((void*) uummy1->packet) ;
	       free ((void*) uummy1 ) ;
			
	       uummy1 = uummy2 ;
	 } 
	  
	 free ((void*) mummy0 ) ;

       }
	 
       else {
	    
	    mummy = mpck ;
	    
	    mfrag = mpck = mpck->next ;
	  
	    uummy1 = mummy->ufrag ;           
       
            while ( uummy1 ) {
	  
	          if (uummy1->next) uummy2 = uummy1->next ;
	          else uummy2 = NULL ;

	          free ((void*) uummy1->packet) ;
		  free ((void*) uummy1 ) ;
		
	          uummy1 = uummy2 ;
	    }
	  
	    free ((void*) mummy) ;
       }
	 
       return (head);
      } 
      else { if ( loctime->tm_sec > mpck->loctime->tm_sec ) {
              if ( (loctime->tm_sec - mpck->loctime->tm_sec) > 30 ) goto loop ;
              else if (mpck) mpck = mpck->next ;
             }
	     else {
	      if ((loctime->tm_sec+60-mpck->loctime->tm_sec) > 30 ) goto loop ;
              else if (mpck) mpck = mpck->next ;
	     }
      }
      
	 
   }
   
   return (NULL);
   
	   
   
}


void *thread_read ( void *in)
{

 unsigned short int packet_lenght ;
   
 struct Header *preheader ;  

 unsigned char head[HEADER] ;
   
 unsigned char *data ;

 unsigned short int version ,lenght ;  
   
 while (1) { 
    
   if ( recv ( Fd.fd ,head ,HEADER ,MSG_PEEK ) < 0 ) { 
       
      fprintf ( stdout,"\nERROR :packet reading error (1)\n\n " );
       
      exit(0);
   }
    
   version = head[0] >> 4 ;
    
   if ( version != 4 ) continue ; 
    
   lenght   = head[2] ;
   lenght <<= 8 ;
   lenght  += head[3] ;

   if (( data = (char*) malloc (lenght+1)) == NULL ) {
              fprintf ( stdout ,"\nERROR :No space for packet data\n\n") ;
              exit (1) ;
   }
    
   if ( read ( Fd.fd , data ,lenght ) < 0 ) {
    
      fprintf (stdout ,"\nERROR :packet reading error (2)\n\n") ;
      exit (0);
   }
    
   preheader = ip_assembly (data) ; 

   free ((void*) data); 
    
   if ( preheader ) { 
	 
       if ( !header ){
	  
	   start = header = preheader ;
           header->next = NULL ;
       }
       else { 

            header->next = preheader ;
    
            header = header->next ;
    
            header->next = NULL ; 
       
       }
      
   }
    
   
 }
   

}



void alarm ( FILE *out2 )
{

  unsigned short int lenght ,count ; 
  char *tmp ; 
   
        fprintf ( Out1,"\nSource       Address %u.%u.%u.%u\n" ,
	                                              start->packet_data[12] ,
	                                              start->packet_data[13] ,
	                                              start->packet_data[14] ,
	                                              start->packet_data[15] );
      
        fprintf ( Out1,"Destination  Address %u.%u.%u.%u\n\n" ,
	                                              start->packet_data[16] ,
	                                              start->packet_data[17] ,
	                                              start->packet_data[18] ,
	                                              start->packet_data[19] );
	
        fprintf ( stdout,"\nSource       Address %u.%u.%u.%u\n\r" ,
	                                              start->packet_data[12] ,
	                                              start->packet_data[13] ,
	                                              start->packet_data[14] ,
	                                              start->packet_data[15] );
      
        fprintf ( stdout,"Destination  Address %u.%u.%u.%u\n\n\r" ,
	                                              start->packet_data[16] ,
	                                              start->packet_data[17] ,
	                                              start->packet_data[18] ,
	                                              start->packet_data[19] );
	
	
	fprintf ( out2   ,"\nSource       Address %u.%u.%u.%u\n" ,
	                                              start->packet_data[12] ,
	                                              start->packet_data[13] ,
	                                              start->packet_data[14] ,
	                                              start->packet_data[15] );
      
        fprintf ( out2   ,"Destination  Address %u.%u.%u.%u\n\n" ,
	                                              start->packet_data[16] ,
	                                              start->packet_data[17] ,
	                                              start->packet_data[18] ,
		                                      start->packet_data[19] );
	

	tmp = start->packet_data  ; 
        lenght = start->packet_lenght  ; 
      
        while ( lenght ) {
	
	   for (count = 1 ;count <=4 ;count ++ ) {
	      
	       if (! lenght ) break ;
	      
	       fprintf ( out2 ,"%2X  " ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
	       
	       fprintf ( Out1 ,"%2X  " ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
	   
	       lenght-- ;
	   }
	
	   fprintf (out2 ,"     ");
	   fprintf (Out1 ,"     ");
	
	   lenght += 4 ;
	
	   for (count = 1;count <=4 ;count++ ) {
	      
	       if (! lenght) break ;
	      
	       if ( isprint ( *(tmp + start->packet_lenght - lenght)) ) {
		  
		  fprintf ( out2 ,"%c" ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
		  fprintf ( Out1 ,"%c" ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
	       }
	       else { fprintf (out2 ,"*") ;fprintf (Out1 ,"*");}
			     
	       lenght--;
			     
	   }
	          
	   fprintf (out2 ,"\n");
	   fprintf (Out1 ,"\n");
	      
        }

	
	fflush (out2) ;
	fclose (out2) ;
        
        fflush (Out1);
	
	fprintf (stdout,"\a\a");
	fflush (stdout);

	
}




void *thread_write ( void *in ) 
{  

 struct Header *dummy ; 
 struct FLAGS  *stflags = Flags ;
 unsigned short int Sport ,Dport ,lenght ,count ,Hlen ,flags ,Nulludp ;
 unsigned int SAddr;
   
 char *tmp ; 

   
 time_t curtime ;
 struct tm *loctime ;

 FILE *out2  ;  
 static unsigned int filenmbr = 1 ;  
 char nmbr[100] ;  

 struct OPTIONS *options = NULL ;    

 mkdir ( Directory , 0777 );
   
 Out1 = fopen ( stcat ( Directory ,"PKDATA" ,1 ) ,"w" );
   
 while ( 1 ) {

  tzset ();  
    
  curtime = time (NULL);  
    
  loctime = localtime (&curtime);    

  if (start) {   
    
   if (start->next ) {

     Hlen = (start->packet_data[0] & 0x0F  ) * 4  ; 
      
     switch ( start->packet_data[9] ) {

	
            case 6:  fprintf (Out1,"\nProtocol TCP\n\n");
	             
	             Sport = 0 ;      
                     Sport = start->packet_data[Hlen+0] ;
                     Sport <<= 8 ;
                     Sport += start->packet_data[Hlen+1] ;
	             Dport = 0 ; 
                     Dport = start->packet_data[Hlen+2] ;
                     Dport <<= 8 ;
                     Dport += start->packet_data[Hlen+3] ;     
                     
		     flags = start->packet_data[Hlen+13] & 0x3F ;

	             options = Options ;
	
	             if ( options ) {
	     
	                while ( options ) {
			   
			 if ( options->opt == 2) { 
			      
			      SAddr =   0 ;
			      SAddr =   start->packet_data[12];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[13];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[14];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[15];

			    
			   if ((((Dport >= options->sport)  &&
				(Dport <= options->eport))  ||   
				((Dport == options->sport)  &&
				 (options->eport == 0 )))   &&    
                              ((((options->saddress >> (32-options->mask) ) &
				(SAddr             >> (32-options->mask)))) ==
			        (SAddr >> (32-options->mask)))
			       ) goto stop ;
			
			 }
			   
			options = options->next ;
			
			}
			
		     }
	
	          do {

		     if ( (stflags->flags & Flags_value[1]) && (!flags) ) 
	                                               flags |= Flags_value[1];
		     
	             if ( (flags == stflags->flags) ) {
			
			out2 = fopen ( stcat (Directory ,
				            iitoa ( filenmbr ,nmbr) ,1),"w");
fprintf(Out1,"\n######################################################\n\n");
fprintf(stdout,"\n######################################################\n\r");
fprintf(out2  ,"\n######################################################\n\n");

                        fprintf ( stdout,"\nProtocol TCP\n\n\r");
	                fprintf ( out2   ,"\nProtocol TCP\n\n");
	             
		        fputs ( asctime(loctime) ,stdout );
	                fputs ( asctime(loctime) ,Out1 );
			fputs ( asctime(loctime) ,out2 );
			
			fprintf (stdout,"\r\n");
			fprintf (Out1,"\n\n");
                        fprintf (out2,"\n\n");
	
	
	                fprintf (stdout ,"FLAGS = " );
	                fprintf (Out1   ,"FLAGS = " );
	                fprintf (out2   ,"FLAGS = " );
	
			count = 1 ;
	
	                while ( Flags_value[count] ){
			   
			  if ( stflags->flags == Flags_value[count] ){
				
	                     fprintf (stdout ,"%s :" ,Flags_name[count]);
	                     fprintf (out2   ,"%s :" ,Flags_name[count]);
			     fprintf (Out1   ,"%s :" ,Flags_name[count]);    
			  }
			  count++;
			}
	
			fprintf (stdout,"\r\n");
			fprintf (Out1,"\r\n");
                        fprintf (out2,"\r\n");
				      

                        fprintf ( stdout,"\nSource      Port %u\r" ,Sport  );
      	                fprintf ( stdout,"\nDestination Port %u\n\r" ,Dport);

			fprintf ( out2   ,"\nSource      Port %u\r" ,Sport );
      	                fprintf ( out2   ,"\nDestination Port %u\n" ,Dport );

		        fprintf ( Out1 ,"\nSource      Port %u\r"   ,Sport );
                        fprintf ( Out1 ,"\nDestination Port %u\n\n" ,Dport );
			
			alarm (out2);
			
			filenmbr++;
		     }
			
		  stflags = stflags->next ;
		     
		     
		  }while ( stflags );
		
                     stflags = Flags ;            
	
	             break ;
            
	
          case  17:  fprintf (Out1,"\nProtocol UDP\n\n");
	             Sport = 0 ;      
                     Sport = start->packet_data[Hlen+0] ;
                     Sport <<= 8 ;
                     Sport += start->packet_data[Hlen+1] ;
	             Dport = 0 ; 
                     Dport = start->packet_data[Hlen+2] ;
                     Dport <<= 8 ;
                     Dport += start->packet_data[Hlen+3] ;     
                     
	             Nulludp   = start->packet_data[Hlen+4] ;
	             Nulludp <<= 8 ;
	             Nulludp  += start->packet_data[Hlen+5] ; 
		
	             
	             options = Options ;
	
	             if ( options ) {
	     
	                while ( options ) {
			   
			 if ( options->opt == 1) { 
			  
			    
			   SAddr =   0 ;
			      SAddr =   start->packet_data[12];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[13];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[14];
			      SAddr <<= 8 ;
	                      SAddr +=  start->packet_data[15];

                           if ((((Dport >= options->sport)  &&
				(Dport <= options->eport))  ||   
				((Dport == options->sport)  &&
				 (options->eport == 0 )))   &&    
                              ((((options->saddress >> (32-options->mask) ) &
				(SAddr             >> (32-options->mask)))) ==
			        (SAddr >> (32-options->mask)))
			       ) goto stop ;
			    
			 }
			   
			 options = options->next ;
			   
			}
			
		     }
	
	          do {
		     
		     if ( (stflags->flags & Flags_value[2]) &&
			  ( Nulludp == 0x08 ) ) flags = Flags_value[2];
		     
		     else if ( (stflags->flags & Flags_value[3]) &&
			      ( Sport > SrcPort || Dport < DstPort ) ) 
		                                      flags = Flags_value[3];
		     else flags = 0 ;
		     
	             if ((flags==Flags_value[2])||(flags==Flags_value[3])){ 

			out2 = fopen ( stcat (Directory ,
					    iitoa ( filenmbr ,nmbr ),1),"w");
			
fprintf(Out1,"\n######################################################\n\n");
fprintf(stdout,"\n######################################################\n\r");
fprintf(out2  ,"\n######################################################\n\r");

                        fprintf ( stdout,"\nProtocol UDP\n\n\r");
	                fprintf ( out2   ,"\nProtocol UDP\n\n");
	             
		        fputs ( asctime(loctime) ,stdout );
	                fputs ( asctime(loctime) ,Out1 );
			fputs ( asctime(loctime) ,out2 );
			
		        fprintf (stdout,"\r\n");
			fprintf (Out1  ,"\n\n");
			fprintf (out2  ,"\n\n");

			
			
	                fprintf (stdout ,"REASON = " );
	                fprintf (Out1   ,"REASON = " );
	                fprintf (out2   ,"REASON = " );
	
			count = 1 ;
			
	                while ( Flags_value[count] ) {
			   
			  if ( flags == Flags_value[count] ){
				
	                     fprintf (stdout ,"%s :" ,Flags_name[count]);
	                     fprintf (out2   ,"%s :" ,Flags_name[count]);
			     fprintf (Out1   ,"%s :" ,Flags_name[count]);    
			  }
			  count++;
			}
	
			fprintf (stdout,"\r\n");
			fprintf (Out1,"\n\n");
                        fprintf (out2,"\n\n");
			
			
			
                        fprintf ( stdout,"\nSource      Port %u\r"   ,Sport );
      	                fprintf ( stdout,"\nDestination Port %u\n\r" ,Dport );
			
			fprintf ( out2  ,"\nSource      Port %u\r" ,Sport);
      	                fprintf ( out2  ,"\nDestination Port %u\n" ,Dport );
		
			fprintf ( Out1 ,"\nSource      Port %u\r"   ,Sport );
                        fprintf ( Out1 ,"\nDestination Port %u\n\n" ,Dport ) ;
			
		        alarm(out2);
			
			filenmbr++;
		     }
	             
		   stflags = stflags->next ;   
		      
		   }while ( stflags );
		    
	             stflags = Flags ;
	
	             break ;

     } 
      
stop:
     fprintf ( Out1, "\nSource      Port %u\r"   ,Sport );
     fprintf ( Out1 ,"\nDestination Port %u\n\n" ,Dport ) ;
 
      
     fprintf ( Out1,"\nSource       Address %u.%u.%u.%u\n" ,
	                                              start->packet_data[12] ,
	                                              start->packet_data[13] ,
	                                              start->packet_data[14] ,
	                                              start->packet_data[15] );
      
     fprintf ( Out1,"Destination  Address %u.%u.%u.%u\n\n" ,
	                                              start->packet_data[16] ,
	                                              start->packet_data[17] ,
	                                              start->packet_data[18] ,
                                                      start->packet_data[19] );
      
     tmp = start->packet_data  ; 
     lenght = start->packet_lenght  ; 
      
     while ( lenght ) {
	
	   for (count = 1 ;count <=4 ;count ++ ) {
	      
	       if (! lenght ) break ;
	      
	       fprintf ( Out1 ,"%2X  " ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
	   
	       lenght-- ;
	   }
	
	   fprintf (Out1 ,"     ");
	
	   lenght += 4 ;
	
	   for (count = 1;count <=4 ;count++ ) {
	      
	       if (! lenght) break ;
	      
	       if ( isprint ( *(tmp + start->packet_lenght - lenght)) ) 
		  
		  fprintf ( Out1 ,"%c" ,
		       (unsigned char)*(tmp +start->packet_lenght - lenght) );
		  
	       else fprintf (Out1 ,"*");
			     
	       lenght--;
			     
	   }
	       
	      
	   fprintf (Out1 ,"\n");   
	      
     }
	
     dummy = start ;
      
     start = start->next ;
      
     free ((void*) dummy->packet_data ) ; 
      
     free ((void*) dummy ) ;
      
     fflush (Out1);

      
   }
   
  }
    
 }

}

 

void term (int sig) 
{
   
   fflush (NULL) ;
   
   fflush (Out1) ;
   
   fclose (Out1) ;

   close (Fd.fd);
   
   pthread_kill ( thread1ID , 9 ) ;
   
   pthread_kill ( thread2ID , 9 ) ;  
   
   exit(0);
   
}


int main (int argc ,char *argv[]) {

 struct in_addr *iddr ;  
 int count = 0 ,count1 = 0 ,number = 0 ;  
 char *letter;
 char *iface ;
 char *stop ,*cvn ,*p ;
 struct FLAGS   *Fdummy ;
 struct OPTIONS *Odummy ;
 int flag = 0 ;

   
 time_t curtime ;
 struct tm *loctime ;
 tzset ();     
 curtime = time (NULL);     
 loctime = localtime (&curtime);    
 Directory = stcat ( "./Pkdump-" , asctime ( loctime ) ,0 ) ;
 p = Directory ;
   
 while (*p) { if ( *p == ' ') *p = '-' ;p++;}
	
 if ( argc < 3 ) {
    printf ("\n\nPKDUMP V.0.96.2 :Usage :pkdump interface [options] \
flags \n \
           Flags   = NULL ,UDPNULL,UDPPORT,FIN,SYN,RST,PSH,ACK,URG,XMAS\n \
           Options = [-U] [startport:endport-address/mask] \n \
           Options = [-T] [startport:endport-address/mask] \n\n  ");
    
    printf ("CTRL C (^C) to exit \n");
    
    exit (1) ;
 }  
 
 if ( argc >2 ) {  

  *argv++ ;
  iface = *argv;  
  *argv++ ;
    
  count = 1 ; 

  while ( Options_name[count] ){  
    
   if ( !strcmp ( *argv ,Options_name[count] ) ) { 
  
	 if ( ! Options ) {
    
                if((Options=Odummy=(struct OPTIONS*) 
		                   malloc(sizeof(struct OPTIONS)))==NULL){
	 fprintf (stdout ,"\n\nERROR :No space for allocating OPTIONS\n\n");
	          exit(1);
                }  

                Options->next = NULL ;
               }
               else {
		     if((Odummy->next=(struct OPTIONS*) 
			            malloc(sizeof(struct OPTIONS)))==NULL){
	 fprintf (stdout ,"\n\nERROR :No space for allocating OPTIONS\n\n");
	              exit(1);
		     }

                     Odummy = Odummy->next ;
	
                     Odummy->next = NULL ;	
               }
	   
	       Odummy->opt = Option_value[count] ;
	 
               *argv++;
     
               cvn = stop = *argv ;  
               for (count1 = 1 ;;count1++) {
		  
		  if ( *stop == '-' ) break ;
		  if ( *stop == ':' ) { flag = 1 ;break ;}
		  else if (count1 > 6) break ;
		  stop++;
	       }
	       if ( count1 > 6 ) {
		  
		  fprintf ( stdout ,"\n\nERROR :SPort out of range\n\n");
		  exit(1);
	       }

               *stop = '\0' ;  
       
               Odummy->sport = atoi ( cvn );
       
               cvn = ++stop ;
       
	       if ( flag ) {

		  flag = 0 ;
		  
		  for (count1 = 1 ;;count1++) {
		  
		      if ( *stop == '-' ) break ;
		      else if (count1 > 6) break ;
		      stop++;
	          }
	          if ( count1 > 6 ) {
		  
		   fprintf ( stdout ,"\n\nERROR :EPort out of range\n\n");
		   exit(1);
	          }
	 
                  *stop = '\0' ;
	 
	          Odummy->eport = atoi ( cvn );
	 
		  if ( Odummy->sport >= Odummy->eport ) {
		   fprintf ( stdout ,"\n\nERROR :Wrong Sport Eport\n\n");
		   exit(1);
	          }
		  
	          cvn = ++stop ;
	       }
               else Odummy->eport = 0 ;	        
      
	       for (count1 = 1 ;;count1++) {
		  
		  if ( *stop == '/') break ;
		  else if (count1 > 16) break ;
		  stop++;
	       }
	       if ( count1 > 16 ) {
		  
		  fprintf (stdout ,"\n\nERROR :SAddress out of range\n\n");
		  exit(1);
	       }
  
	       *stop = '\0' ;
	
	       if ( !inet_aton ( cvn ,iddr ) ) {	  
                   fprintf (stdout ,"\n\nERROR :SAddress not valid\n\n");
		   exit(1);
	       }
	       else Odummy->saddress = (unsigned int) htonl (inet_addr (cvn)); 
      
               cvn = ++stop ;
	
	       for (count1 = 1 ;;count1++) {
		  
		  if ( *stop == '\0') break ;
		  else if (count1 > 3) break ;
		  stop++ ;
	       }
	       if ( count1 > 3 ) {
		  
		  fprintf (stdout ,"\n\nERROR :Mask out of range\n\n");
		  exit(1);
	       }
	       
	       *stop = '\0' ;
	
	       Odummy->mask = atoi ( cvn );
	
	       if ( Odummy->mask > 32 ) {
		  
		  fprintf (stdout ,"\n\nERROR :Mask out of range\n\n");
		  exit(1);
	       }

               *argv++;
      
               if ( ! *argv) {  
     
                  fprintf (stdout ,"\n\nERROR : Missing flags \n\n");
	          exit (1);
               }

      
	       count = 1 ;continue ;
	 
      
   }
     
   count++ ;  
     
  }   
    
  while ( *argv ) { 
	 
      letter = *argv ;
     
      while ( *letter ) { 
	    if (*letter >= 0x61) *letter -= 0x20 ;
	    letter ++;
      }	  

      count = 0 ;
     
      while ( Flags_name[count] ) {	 
	 
       if (!strcmp ( *argv ,Flags_name[count] ) ) {
	  
	flag = 1 ;  
	  
        if (!Flags) {	  
	       
	 if((Flags=Fdummy=(struct FLAGS*)malloc(sizeof(struct FLAGS)))==NULL){
	    fprintf (stdout ,"\n\nERROR :No space for allocating FLAGS\n\n");
	    exit(1);
	 }
	 Fdummy->flags = Flags_value[count] ;
	 Fdummy->next  = NULL ;
         
	}  
	else {
	   
	 if ((Fdummy->next=(struct FLAGS*)malloc(sizeof(struct FLAGS)))==NULL){
	    fprintf (stdout , "\n\nERROR :No space for allocating FLAGS\n\n");
	    exit(1);
	 }    
	  
	 Fdummy = Fdummy->next ;
	 Fdummy->flags = Flags_value[count] ;
	 Fdummy->next  = NULL ;
	     
	}
	  
	  
       }
	 
       count ++;	 
	 
      }
      
      if ( ! flag  ) {
	fprintf (stdout ,"\n\nERROR : Flags don't recognized \n\n");
	exit (1);
      }
      
      flag = 0 ;
      
      *argv++;
  }
      
    
 }
   
   
   
 
	 
     
   
   
 Fd.fd = if_pr_set ( iface ) ;
   
 pthread_setconcurrency (2) ;
 
   
   
 pthread_create (&thread1ID ,NULL ,thread_read  ,NULL ) ;  

 pthread_create (&thread2ID ,NULL ,thread_write ,NULL ) ;  
   
 
 signal ( SIGINT ,term );  
   
   
 pthread_join ( thread2ID ,NULL ) ;

 fflush (NULL) ;

 close (Fd.fd);
   
 pthread_kill ( thread1ID , 9 ) ;
   
 exit (0);
   
}
    
